import { defineComponent, openBlock, createElementBlock, normalizeClass, toDisplayString, createCommentVNode, createElementVNode, useCssVars, unref, computed, Fragment, createBlock, resolveComponent, withCtx, renderSlot, createVNode } from 'vue';

const _hoisted_1$3 = ["for"];
const _hoisted_2$1 = ["type", "id", "name", "value", "placeholder", "autocomplete", "disabled", "required"];
var script$3 = /*#__PURE__*/defineComponent({
  props: {
    type: null,
    name: null,
    label: null,
    modelValue: {
      default: ''
    },
    placeholder: null,
    autocomplete: {
      default: 'off'
    },
    enterKeyHint: null,
    labelHidden: {
      type: Boolean
    },
    disabled: {
      type: Boolean
    },
    required: {
      type: Boolean
    },
    block: {
      type: Boolean
    }
  },
  emits: ['update:modelValue'],

  setup(__props, _ref) {
    let {
      emit
    } = _ref;
    const props = __props;

    function onChangeInput(event) {
      const target = event.target;
      emit('update:modelValue', target.value);
    }

    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(['input-text', {
          'input-text--block': props.block
        }])
      }, [props.label ? (openBlock(), createElementBlock("label", {
        key: 0,
        for: props.name,
        class: normalizeClass(['input-text__label', {
          'sr-only': props.labelHidden || 'hidden' === props.type
        }])
      }, toDisplayString(props.label + (__props.required ? ' *' : '')), 11, _hoisted_1$3)) : createCommentVNode("", true), createElementVNode("input", {
        class: "input-text__field",
        type: props.type,
        id: props.name,
        name: props.name,
        value: props.modelValue,
        placeholder: props.placeholder,
        autocomplete: props.autocomplete,
        disabled: props.disabled,
        required: props.required,
        invalid: true,
        onInput: onChangeInput
      }, null, 40, _hoisted_2$1)], 2);
    };
  }

});

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$2 = ".input-text {\n  position: relative;\n}\n.input-text__label {\n  font-weight: 600;\n  line-height: 1.75rem;\n}\n.input-text__field {\n  display: block;\n}\n.input-text__field:disabled {\n  opacity: 0.7;\n}\n.input-text__field:required {\n  color: darkorange;\n}\n.input-text__field:invalid {\n  color: red;\n}\n.input-text--block {\n  width: 100%;\n}\n.input-text--block .input-text__field {\n  width: 100%;\n}\n.sr-only {\n  position: absolute;\n  overflow: hidden;\n  width: 1px;\n  height: 1px;\n  padding: 0;\n  border: 0;\n  margin: -1px;\n  clip-path: polygon(0 0, 0 0, 0 0);\n}";
styleInject(css_248z$2);

const _hoisted_1$2 = ["href"];
var script$2 = /*#__PURE__*/defineComponent({
  props: {
    name: null,
    description: null,
    size: {
      default: 'md'
    },
    width: null,
    height: null
  },

  setup(__props) {
    const props = __props;

    useCssVars(_ctx => ({
      "4aa05852": unref(widthC),
      "5b3a5ea2": unref(heightC)
    }));

    const sizeC = computed(() => props.height && props.width ? 'custom' : props.size);
    const widthC = computed(() => props.width ?? '24px');
    const heightC = computed(() => props.height ?? '24px');
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("svg", {
        class: normalizeClass(['icon', 'icon--size-' + unref(sizeC)])
      }, [createElementVNode("desc", null, toDisplayString(__props.description ? __props.description : __props.name), 1), createElementVNode("use", {
        href: '#' + __props.name
      }, null, 8, _hoisted_1$2)], 2);
    };
  }

});

var css_248z$1 = ".icon {\n  --icon-gutter: var(--ui-global-gutter, 0.25rem);\n  color: currentColor;\n  flex-shrink: 0;\n  height: var(--icon-size, 24px);\n  width: var(--icon-size, 24px);\n}\n.icon--size-xs {\n  --icon-size: calc(var(--icon-gutter) * 3);\n}\n.icon--size-sm {\n  --icon-size: calc(var(--icon-gutter) * 4);\n}\n.icon--size-md {\n  --icon-size: calc(var(--icon-gutter) * 6);\n}\n.icon--size-lg {\n  --icon-size: calc(var(--icon-gutter) * 9);\n}\n.icon--size-xl {\n  --icon-size: calc(var(--icon-gutter) * 12);\n}\n.icon--size-custom {\n  height: var(--4aa05852);\n  width: var(--5b3a5ea2);\n}";
styleInject(css_248z$1);

const _hoisted_1$1 = {
  key: 2,
  class: "button__text"
};
var script$1 = /*#__PURE__*/defineComponent({
  props: {
    text: null,
    icon: null,
    loading: {
      type: Boolean
    },
    iconSize: {
      default: 'md'
    }
  },

  setup(__props) {
    const props = __props;
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [props.loading ? (openBlock(), createBlock(script$2, {
        key: 0,
        class: "button__loading",
        name: "loading",
        size: props.iconSize
      }, null, 8, ["size"])) : props.icon ? (openBlock(), createBlock(script$2, {
        key: 1,
        class: "button__icon",
        name: props.icon,
        size: props.iconSize
      }, null, 8, ["name", "size"])) : createCommentVNode("", true), props.text ? (openBlock(), createElementBlock("span", _hoisted_1$1, toDisplayString(props.text), 1)) : createCommentVNode("", true)], 64);
    };
  }

});

const _hoisted_1 = ["href"];
const _hoisted_2 = ["type", "disabled"];
var script = /*#__PURE__*/defineComponent({
  props: {
    type: {
      default: 'button'
    },
    icon: null,
    text: null,
    href: null,
    to: null,
    theme: {
      default: 'transparent'
    },
    color: {
      default: 'default'
    },
    size: {
      default: 'md'
    },
    iconSize: null,
    align: {
      default: 'center'
    },
    block: {
      type: Boolean
    },
    reverseOrder: {
      type: Boolean
    },
    disabled: {
      type: Boolean
    },
    loading: {
      type: Boolean
    }
  },
  emits: ['clicked'],

  setup(__props, _ref) {
    let {
      emit
    } = _ref;
    const props = __props;
    const classes = computed(() => ['button', 'button--theme-' + props.theme, 'button--color-' + props.color, 'button--align-' + props.align, 'button--size-' + props.size, {
      'button--block': props.block,
      'button--reverse': props.reverseOrder,
      // 'button--rounded': props.icon && !props.text,
      'button--disabled': props.disabled
    }]);
    const iconSizeComp = computed(() => props.iconSize ?? props.size);

    function clicked(event) {
      emit('clicked', event);
    }

    return (_ctx, _cache) => {
      const _component_router_link = resolveComponent("router-link");

      return props.to && !props.disabled ? (openBlock(), createBlock(_component_router_link, {
        key: 0,
        class: normalizeClass(unref(classes)),
        to: props.to
      }, {
        default: withCtx(() => [renderSlot(_ctx.$slots, "default", {}, () => [createVNode(script$1, {
          text: props.text,
          icon: props.icon,
          loading: props.loading,
          iconSize: unref(iconSizeComp)
        }, null, 8, ["text", "icon", "loading", "iconSize"])])]),
        _: 3
      }, 8, ["class", "to"])) : props.href && !props.disabled ? (openBlock(), createElementBlock("a", {
        key: 1,
        class: normalizeClass(unref(classes)),
        href: props.href,
        target: "_blank",
        rel: "noopener noreferrer"
      }, [renderSlot(_ctx.$slots, "default", {}, () => [createVNode(script$1, {
        text: props.text,
        icon: props.icon,
        loading: props.loading,
        iconSize: unref(iconSizeComp)
      }, null, 8, ["text", "icon", "loading", "iconSize"])])], 10, _hoisted_1)) : (openBlock(), createElementBlock("button", {
        key: 2,
        class: normalizeClass(unref(classes)),
        type: props.type,
        onClick: clicked,
        disabled: props.disabled
      }, [renderSlot(_ctx.$slots, "default", {}, () => [createVNode(script$1, {
        text: props.text,
        icon: props.icon,
        loading: props.loading,
        iconSize: unref(iconSizeComp)
      }, null, 8, ["text", "icon", "loading", "iconSize"])])], 10, _hoisted_2));
    };
  }

});

var css_248z = ".button {\n  --button-gutter: var(--ui-global-gutter, 0.25rem);\n  --button-padding: calc(var(--button-gutter) * 2);\n  --button-color: rgb(128, 128, 128);\n  --button-bg-color: transparent;\n  --button-text-color: var(--ui-global-color-black, hsl(0, 0%, 11%));\n  --button-border-color: transparent;\n  border: 0;\n  border-radius: 2rem;\n  background-color: var(--button-bg-color);\n  color: var(--button-text-color);\n  display: inline-flex;\n  appearance: none;\n  text-decoration: none;\n  cursor: pointer;\n  box-sizing: border-box;\n  align-items: center;\n  gap: calc(var(--button-gutter) * 2);\n  padding: var(--button-padding) calc(var(--button-padding) * 3);\n  box-shadow: 0px 0px 0px 2px var(--button-border-color) inset;\n  background-position: center;\n  transition: background, color;\n  transition-duration: 0.5s;\n  font-size: var(--button-font-size);\n}\n.button:hover {\n  background: var(--button-bg-color) radial-gradient(circle, transparent 1%, var(--button-bg-color) 1%) center/15000%;\n  text-decoration: none;\n  -webkit-text-stroke: 0;\n}\n.button:active {\n  background-size: 100%;\n  transition-duration: 0s;\n}\n.button--size-sm {\n  --button-font-size: calc(var(--button-gutter) * 3.5);\n  --button-padding: var(--button-gutter);\n}\n.button--size-md {\n  --button-font-size: calc(var(--button-gutter) * 4);\n  --button-padding: calc(var(--button-gutter) * 2);\n}\n.button--size-lg {\n  --button-font-size: calc(var(--button-gutter) * 4.5);\n  --button-padding: calc(var(--button-gutter) * 2.5);\n}\n.button--theme-solid {\n  --button-text-color: white;\n  --button-border-color: var(--button-color);\n  --button-bg-color: var(--button-color);\n}\n.button--theme-outline {\n  --button-text-color: var(--button-color);\n  --button-border-color: var(--button-color);\n  --button-bg-color: transparent;\n}\n.button--theme-outline:hover, .button--theme-outline:active {\n  --button-text-color: white;\n  --button-bg-color: var(--button-color);\n}\n.button--theme-transparent {\n  --button-text-color: var(--button-color);\n  --button-border-color: transparent;\n  --button-bg-color: transparent;\n}\n.button--theme-transparent:hover, .button--theme-transparent:active {\n  --button-text-color: white;\n  --button-bg-color: var(--button-color);\n}\n.button--theme-text {\n  --button-text-color: var(--button-color);\n  --button-border-color: transparent;\n  --button-bg-color: transparent;\n  --button-padding: 0;\n}\n.button--theme-text:hover {\n  text-decoration: underline;\n  -webkit-text-stroke: 0.5px;\n}\n.button--color-default {\n  --button-color: var(--ui-global-color-grey--400);\n}\n.button--color-default:hover, .button--color-default:focus {\n  --button-color: var(--ui-global-color-grey--600);\n}\n.button--color-default:active {\n  --button-color: var(--ui-global-color-grey--800);\n}\n.button--color-primary {\n  --button-color: var(--ui-global-color-primary--400);\n}\n.button--color-primary:hover, .button--color-primary:focus {\n  --button-color: var(--ui-global-color-primary--600);\n}\n.button--color-primary:active {\n  --button-color: var(--ui-global-color-primary--800);\n}\n.button--color-secondary {\n  --button-color: var(--ui-global-color-secondary--400);\n}\n.button--color-secondary:hover, .button--color-secondary:focus {\n  --button-color: var(--ui-global-color-secondary--600);\n}\n.button--color-secondary:active {\n  --button-color: var(--ui-global-color-secondary--800);\n}\n.button--color-success {\n  --button-color: var(--ui-global-color-success--400);\n}\n.button--color-success:hover, .button--color-success:focus {\n  --button-color: var(--ui-global-color-success--600);\n}\n.button--color-success:active {\n  --button-color: var(--ui-global-color-success--800);\n}\n.button--color-warning {\n  --button-color: var(--ui-global-color-warning--400);\n}\n.button--color-warning:hover, .button--color-warning:focus {\n  --button-color: var(--ui-global-color-warning--600);\n}\n.button--color-warning:active {\n  --button-color: var(--ui-global-color-warning--800);\n}\n.button--color-error {\n  --button-color: var(--ui-global-color-error--400);\n}\n.button--color-error:hover, .button--color-error:focus {\n  --button-color: var(--ui-global-color-error--600);\n}\n.button--color-error:active {\n  --button-color: var(--ui-global-color-error--800);\n}\n.button--align-left {\n  justify-content: flex-start;\n}\n.button--align-center {\n  justify-content: center;\n}\n.button--align-right {\n  justify-content: flex-end;\n}\n.button--align-space-between {\n  justify-content: space-between;\n}\n.button--block {\n  display: flex;\n  width: 100%;\n}\n.button--loading {\n  pointer-events: none;\n}\n.button--reverse {\n  flex-direction: row-reverse;\n}\n.button--disabled {\n  cursor: not-allowed;\n  opacity: 0.6;\n}\n.button--disabled:hover, .button--disabled:active {\n  opacity: 0.8;\n}";
styleInject(css_248z);

/* eslint-disable import/prefer-default-export */

var components = /*#__PURE__*/Object.freeze({
  __proto__: null,
  UIInputText: script$3,
  UIIcon: script$2,
  UIButton: script
});

// Import vue components

const install = function installVueComponentsUi(app) {
  Object.entries(components).forEach(_ref => {
    let [componentName, component] = _ref;
    app.component(componentName, component);
  });
}; // Create module definition for Vue.use()

export { script as UIButton, script$2 as UIIcon, script$3 as UIInputText, install as default };
